EnableExplicit
XIncludeFile "GadgetLayout.pbi"

ProcedureDLL.s GetDesignerExtension()
   Static DesignerExtension.s="material"
   ProcedureReturn DesignerExtension
EndProcedure

ProcedureDLL.s GetDesignerDescription()
   Static DesignerDescription.s="Name=ORGRE Material Designer|Author=Eddy|Version=1.0|"
   ProcedureReturn DesignerDescription
EndProcedure

Structure CUSTOM_DESINGER_DATA
   splitter.i
   rightPanel.i
   matTree.i
   addPass.i
   addTechnique.i
   sphere.i
EndStructure


ProcedureDLL OpenDesigner(*parent, *scintilla)  
   Protected *designerData.CUSTOM_DESINGER_DATA=AllocateMemory(SizeOf(CUSTOM_DESINGER_DATA))
   With *designerData
      ; YOUR CODE HERE...
      
      ;{
      UseGadgetList(*parent)
      Protected container=ContainerGadget(#PB_Any,0,0,300,300,#PB_Container_Single)
      If container      
         UseGadgetLayout(container,10,10,10,10)
         \matTree=TreeGadget(#PB_Any, 180, 10, 160, 160) 
         AddGadgetItem (\matTree, -1, "Material", 0, 0) 
         AddGadgetItem (\matTree, -1, "Technique", 0, 1) 
         AddGadgetItem (\matTree, -1, "Pass1", 0, 2) 
         AddGadgetItem (\matTree, -1, "Pass2", 0, 2) 
         AddGadgetItem (\matTree, -1, "Technique", 0, 1) 
         AddGadgetItem (\matTree, -1, "Pass1", 0, 2) 
         SetGadgetState(\matTree,3)
         
         \rightPanel=ContainerGadget(#PB_Any,0,0,0,0,#PB_Container_Single)
         UseGadgetLayout(\rightPanel,5,5,5,5)
         ;>
            \addPass=ButtonGadget(#PB_Any,0,0,100,25,"Add Pass")
            AnchorGadget(\addPass,0,#PB_Ignore,#PB_Ignore,0)
            \addTechnique=ButtonGadget(#PB_Any,0,0,100,25,"Add Technique")
            AnchorGadget(\addTechnique,0,#PB_Ignore,#PB_Ignore,30)
         ;<
         CloseGadgetList()
         
         UseGadgetLayout(container)
         \splitter=SplitterGadget(#PB_Any,0,0,0,0,\matTree,\rightPanel, #PB_Splitter_Vertical)
         SetGadgetAttribute(\splitter,#PB_Splitter_FirstMinimumSize,150)
         SetGadgetState(\splitter,150)
         DockGadget(\splitter,#Dock_Fill)
         
         CloseGadgetList()
      EndIf 
      CloseGadgetList()
      ;} 
      
      SetGadgetData(container,*designerData)
      ProcedureReturn container
   EndWith 
EndProcedure

ProcedureDLL CloseDesigner(container)   
   Protected *designerData.CUSTOM_DESINGER_DATA=GetGadgetData(container)
   With *designerData
      ; YOUR CODE HERE...
      
      FreeMemory(*designerData)
      FreeGadget(container)
      AutoResizeGadgets()
      
   EndWith
EndProcedure

ProcedureDLL SynchronizeDesigner(container) 
   Protected *designerData.CUSTOM_DESINGER_DATA=AllocateMemory(SizeOf(CUSTOM_DESINGER_DATA))
   With *designerData
      ; YOUR CODE HERE...   
   
   EndWith   
EndProcedure 

ProcedureDLL HideDesigner(container,hidden)   
   Protected *designerData.CUSTOM_DESINGER_DATA=GetGadgetData(container)
   With *designerData
      ; YOUR CODE HERE...
   EndWith
EndProcedure

ProcedureDLL SizeDesigner(container,w,h)   
   Protected *designerData.CUSTOM_DESINGER_DATA=GetGadgetData(container)
   With *designerData
      ; YOUR CODE HERE...
      AutoResizeGadgets()
   EndWith
EndProcedure

ProcedureDLL EventDesigner(container)   
   Protected *designerData.CUSTOM_DESINGER_DATA=GetGadgetData(container)
   With *designerData
      ; YOUR CODE HERE...
      
      ;{
      Protected event=WaitWindowEvent()
      If event=#PB_Event_Gadget
         If EventType()=#PB_EventType_LeftClick
            If EventGadget()=\addPass
               MessageRequester("Material","addPass")
            EndIf 
            If EventGadget()=\addTechnique
               MessageRequester("Material","addTechnique")
            EndIf 
         EndIf
      EndIf 
      ;}
      
   EndWith 
EndProcedure 
; IDE Options = PureBasic 5.10 Beta 5 (Windows - x64)
; ExecutableFormat = Shared Dll
; CursorPosition = 19
; Folding = Dw
; EnableXP